// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from metro_benchmark_msgs:msg/ComputeTime.idl
// generated code does not contain a copyright notice
#include "metro_benchmark_msgs/msg/detail/compute_time__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `duration`
#include "builtin_interfaces/msg/detail/duration__functions.h"
// Member `id`
// Member `parent_id`
#include "rosidl_runtime_c/string_functions.h"

bool
metro_benchmark_msgs__msg__ComputeTime__init(metro_benchmark_msgs__msg__ComputeTime * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    metro_benchmark_msgs__msg__ComputeTime__fini(msg);
    return false;
  }
  // duration
  if (!builtin_interfaces__msg__Duration__init(&msg->duration)) {
    metro_benchmark_msgs__msg__ComputeTime__fini(msg);
    return false;
  }
  // id
  if (!rosidl_runtime_c__String__init(&msg->id)) {
    metro_benchmark_msgs__msg__ComputeTime__fini(msg);
    return false;
  }
  // parent_id
  if (!rosidl_runtime_c__String__init(&msg->parent_id)) {
    metro_benchmark_msgs__msg__ComputeTime__fini(msg);
    return false;
  }
  return true;
}

void
metro_benchmark_msgs__msg__ComputeTime__fini(metro_benchmark_msgs__msg__ComputeTime * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // duration
  builtin_interfaces__msg__Duration__fini(&msg->duration);
  // id
  rosidl_runtime_c__String__fini(&msg->id);
  // parent_id
  rosidl_runtime_c__String__fini(&msg->parent_id);
}

bool
metro_benchmark_msgs__msg__ComputeTime__are_equal(const metro_benchmark_msgs__msg__ComputeTime * lhs, const metro_benchmark_msgs__msg__ComputeTime * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // duration
  if (!builtin_interfaces__msg__Duration__are_equal(
      &(lhs->duration), &(rhs->duration)))
  {
    return false;
  }
  // id
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->id), &(rhs->id)))
  {
    return false;
  }
  // parent_id
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->parent_id), &(rhs->parent_id)))
  {
    return false;
  }
  return true;
}

bool
metro_benchmark_msgs__msg__ComputeTime__copy(
  const metro_benchmark_msgs__msg__ComputeTime * input,
  metro_benchmark_msgs__msg__ComputeTime * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // duration
  if (!builtin_interfaces__msg__Duration__copy(
      &(input->duration), &(output->duration)))
  {
    return false;
  }
  // id
  if (!rosidl_runtime_c__String__copy(
      &(input->id), &(output->id)))
  {
    return false;
  }
  // parent_id
  if (!rosidl_runtime_c__String__copy(
      &(input->parent_id), &(output->parent_id)))
  {
    return false;
  }
  return true;
}

metro_benchmark_msgs__msg__ComputeTime *
metro_benchmark_msgs__msg__ComputeTime__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  metro_benchmark_msgs__msg__ComputeTime * msg = (metro_benchmark_msgs__msg__ComputeTime *)allocator.allocate(sizeof(metro_benchmark_msgs__msg__ComputeTime), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(metro_benchmark_msgs__msg__ComputeTime));
  bool success = metro_benchmark_msgs__msg__ComputeTime__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
metro_benchmark_msgs__msg__ComputeTime__destroy(metro_benchmark_msgs__msg__ComputeTime * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    metro_benchmark_msgs__msg__ComputeTime__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
metro_benchmark_msgs__msg__ComputeTime__Sequence__init(metro_benchmark_msgs__msg__ComputeTime__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  metro_benchmark_msgs__msg__ComputeTime * data = NULL;

  if (size) {
    data = (metro_benchmark_msgs__msg__ComputeTime *)allocator.zero_allocate(size, sizeof(metro_benchmark_msgs__msg__ComputeTime), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = metro_benchmark_msgs__msg__ComputeTime__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        metro_benchmark_msgs__msg__ComputeTime__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
metro_benchmark_msgs__msg__ComputeTime__Sequence__fini(metro_benchmark_msgs__msg__ComputeTime__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      metro_benchmark_msgs__msg__ComputeTime__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

metro_benchmark_msgs__msg__ComputeTime__Sequence *
metro_benchmark_msgs__msg__ComputeTime__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  metro_benchmark_msgs__msg__ComputeTime__Sequence * array = (metro_benchmark_msgs__msg__ComputeTime__Sequence *)allocator.allocate(sizeof(metro_benchmark_msgs__msg__ComputeTime__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = metro_benchmark_msgs__msg__ComputeTime__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
metro_benchmark_msgs__msg__ComputeTime__Sequence__destroy(metro_benchmark_msgs__msg__ComputeTime__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    metro_benchmark_msgs__msg__ComputeTime__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
metro_benchmark_msgs__msg__ComputeTime__Sequence__are_equal(const metro_benchmark_msgs__msg__ComputeTime__Sequence * lhs, const metro_benchmark_msgs__msg__ComputeTime__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!metro_benchmark_msgs__msg__ComputeTime__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
metro_benchmark_msgs__msg__ComputeTime__Sequence__copy(
  const metro_benchmark_msgs__msg__ComputeTime__Sequence * input,
  metro_benchmark_msgs__msg__ComputeTime__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(metro_benchmark_msgs__msg__ComputeTime);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    metro_benchmark_msgs__msg__ComputeTime * data =
      (metro_benchmark_msgs__msg__ComputeTime *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!metro_benchmark_msgs__msg__ComputeTime__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          metro_benchmark_msgs__msg__ComputeTime__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!metro_benchmark_msgs__msg__ComputeTime__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
